Bug 1505445 (CVE-2017-13090)

Summary: CVE-2017-13090 wget: Heap-based buffer overflow in HTTP protocol handling
Product: [Other] Security Response Reporter: Adam Mariš <amaris>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: unspecifiedCC: cperry, karsten, mzibrick, security-response-team, skontar, thozza, yozone
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=important,public=20171026:1500,reported=20171023,source=distros,cvss3=7.8/CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H,cwe=CWE-122,rhel-5/wget=notaffected,rhel-6/wget=notaffected,rhel-7/wget=affected,fedora-all/wget=affected
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
A heap-based buffer overflow, when processing chunked encoded HTTP responses, was found in wget. By tricking an unsuspecting user into connecting to a malicious HTTP server, an attacker could exploit this flaw to potentially execute arbitrary code.
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-10-27 09:59:01 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1505488, 1505489, 1505490, 1505491, 1506720, 1561420    
Bug Blocks: 1505449    
Attachments:
Description Flags
Upstream patch none

Description Adam Mariš 2017-10-23 15:09:43 UTC
A heap-based buffer overflow vulnerability was found in HTTP protocol handling, potentially allowing a code execution.

The retr.c:fd_read_body() function is called when processing OK responses. When the response is sent chunked, the chunk parser uses strtol() to read each chunk's length, but doesn't check that the chunk length is a non-negative number. The code then tries to read the chunk in pieces of 8192 bytes by using the MIN() macro, but ends up passing the negative chunk length to retr.c:fd_read(). As fd_read() takes an int argument, the high 32 bits of the chunk length are discarded, leaving fd_read() with a completely attacker controlled length argument. The attacker can corrupt malloc metadata after the allocated buffer.

Comment 2 Adam Mariš 2017-10-23 15:10 UTC
Created attachment 1342259 [details]
Upstream patch

Comment 7 Adam Mariš 2017-10-24 08:45:04 UTC
Acknowledgments:

Name: the GNU Wget project

Comment 9 Stefan Cornelius 2017-10-24 11:14:23 UTC
Looks like this was introduced via
http://git.savannah.gnu.org/cgit/wget.git/commit/?id=1cee0861627ce56a880fa300960136aac0cf0fe1

RHEL6 does not have this code.

Comment 11 Stefan Cornelius 2017-10-26 09:32:41 UTC
Statement:

This issue affects the versions of wget as shipped with Red Hat Enterprise Linux 7. This issue did not affect the versions of wget as shipped with Red Hat Enterprise Linux 5 and 6.

Comment 13 Stefan Cornelius 2017-10-26 16:10:40 UTC
Created wget tracking bugs for this issue:

Affects: fedora-all [bug 1506720]

Comment 15 errata-xmlrpc 2017-10-26 16:46:10 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2017:3075 https://access.redhat.com/errata/RHSA-2017:3075